=== modified file 'madgraph/core/base_objects.py'
--- madgraph/core/base_objects.py	2010-08-23 08:20:06 +0000
+++ madgraph/core/base_objects.py	2010-08-24 06:02:39 +0000
@@ -723,22 +723,26 @@
             self['ref_dict_to0'] = {}
             self['particle_dict'] = {}
             self['got_majoranas'] = None
+
+        if name == 'interactions':
+            # Reset dictionaries
+            self['interaction_dict'] = {}
+            self['ref_dict_to1'] = {}
+            self['ref_dict_to0'] = {}
+
+        Model.__bases__[0].set(self, name, value) # call the mother routine
+
+        if name == 'particles':
             # Generate new dictionaries
             self.get('particle_dict')
             self.get('got_majoranas')
 
         if name == 'interactions':
-            # Reset dictionaries
-            self['interaction_dict'] = {}
-            self['ref_dict_to1'] = {}
-            self['ref_dict_to0'] = {}
             # Generate new dictionaries
             self.get('interaction_dict')
             self.get('ref_dict_to1')
             self.get('ref_dict_to0')
 
-        Model.__bases__[0].set(self, name, value) # call the mother routine
-
     def get_sorted_keys(self):
         """Return process property names as a nicely sorted list."""
 

=== modified file 'tests/unit_tests/core/test_base_objects.py'
--- tests/unit_tests/core/test_base_objects.py	2010-08-13 08:25:50 +0000
+++ tests/unit_tests/core/test_base_objects.py	2010-08-24 03:44:06 +0000
@@ -631,6 +631,39 @@
 
         myinterdict = {1:self.myinterlist[0]}
         self.assertEqual(myinterdict, self.mymodel.get('interaction_dict'))
+
+        particles = copy.copy(self.mymodel.get('particles'))
+        particles.append(base_objects.Particle({'name':'a',
+                  'antiname':'a',
+                  'spin':3,
+                  'color':0,
+                  'mass':'zero',
+                  'width':'zero',
+                  'texname':'\gamma',
+                  'antitexname':'\gamma',
+                  'line':'wavy',
+                  'charge':0.,
+                  'pdg_code':22,
+                  'propagating':True,
+                  'self_antipart':True}))
+        self.mymodel.set('particles', particles)
+        mypartdict[22] = particles[2]
+        self.assertEqual(mypartdict, self.mymodel['particle_dict'])
+
+        interactions = copy.copy(self.mymodel.get('interactions'))
+        interactions.append(base_objects.Interaction({
+                      'id':2,
+                      'particles': base_objects.ParticleList(\
+                                            [self.mypartlist[0], \
+                                             antitop, \
+                                             self.mymodel['particles'][2]]),
+                      'color': [],
+                      'lorentz':['L1'],
+                      'couplings':{(0, 0):'GQED'},
+                      'orders':{'QED':1}}))
+        self.mymodel.set('interactions', interactions)
+        myinterdict[2] = interactions[1]
+        self.assertEqual(myinterdict, self.mymodel['interaction_dict'])
         
     def test_pass_in_standard_name(self):
         """Test if we can overwrite the name of the model following MG 

